function farben 
  LOCAL array,colstring,palette 
  LOCAL colText, colBack ,color 
  LOCAL key, col ,  row ,col1,row1 
   
  *   Kleines Utility zur Ermittlung eines Farbstrings. 
  *   Alle mglichen Farbkombinationen werden als 16 auf 8 
  *   Array dargestellt. Innerhalb dieses Arrays kann mit 
  *   den Cursortasten eine der mglichen Kombinationen 
  *   ausgewhlt werden. 

  array = array( 16, 8) 

  DO WHILE .t.
    setcolor("")
    CLEAR SCREEN 
    dispbox( 0, 0 ,21, 54 ,1) 

    RUN ARRAYINIT 

    RUN ArrayGet 

    setcolor(color) 
    wall() 
    tone(200,4) 
    tone(200,2) 
    alarm("Ihre Farbauswahl :" +color) 

    IF alarm("Programm beenden ? ",{"JA","NEIN"}) = 1
     EXIT
    ENDIF

  ENDDO

RETURN                                  
 
 
PROCEDURE ArrayGet 
  col = 1 
  row = 4 
  dispbox(18, 1,18, 53,1) 
  say( 18,0,"") 
  say( 18,54,"") 
   
  say( 19,2, "Auswahl: <"+CHR(27)+CHR( 24)+CHR(25)+CHR(26)+">  ") 
  say( 19, COL(),"Ende: <Enter>  Abbruch: <Escape>") 

  RUN ARRAYShow 
   
  DO WHILE .T.  
     
    * -- Beispieltext in gewhlter Farbe zeigen -- 
    say( 0,3 ," Beispieltext ",array[ col, row]) 
    say( 0,40,RIGHT( "[" + array[ col, row] + "]", 10)) 
     
    * -- aktuelle Auswahl einrahmen -- 
    dispbox(row * 2 - 1, col * 3 - 1 , row * 2 + 1, col * 3 + 2,1) 
     
    key = INKEY( 0)  
     
    dispbox(row * 2 - 1, col * 3 - 1, row * 2 + 1, col * 3 + 2,SPACE( 8)) 
     
    DO CASE  
       
     CASE key =  5 
      row = row +  7 
     CASE key = 24 
      row = row +  1 
     CASE key =  4  
      col = col +  1 
     CASE key = 19  
      col = col + 15 
     CASE key = 27  
      EXIT 
     CASE key = 13                
      color = array[ col, row] 
      EXIT 
    ENDCASE                             
     
    col = 1 + ( col - 1) % 16 
    row = 1 + ( row - 1) %  8 
     
  ENDDO                                 
   
PROCEND                                 
   


   
PROCEDURE ArrayShow                     
   
 *   Stellt alle Farbkombinationen aus dem 
 *   <array> als String der Form "Xx" dar. 
 * 
 *   Das Array hat 16 auf 8 Dimensionen. 
   
  FOR row1 = 1 TO 8                    
    FOR col1 = 1 TO 16               
      * -- Den aktuellen Farbstring mit @ .. SAY .. COLOR ausgeben -- 
      say( row1 * 2, col1 * 3 , "Xx",array[ col1, row1]) 
    NEXT                                
  NEXT                                  
PROCEND                                 
   
* -------------------------------------------------------------- 
   
PROCEDURE ArrayInit                     
   
 *   Belegt das Farbarray <array> mit den xBASE 
 *   Farbkombinationen vor. Bercksichtigt werden 
 *   alle Kombinationen aus 16 mglichen Vorder- 
 *   grundfarben (8 Grundfarben plus die 8 Farben 
 *   aufgehellt) und den 8 Hintergrundfarben. 
 * 
 *   Das Array hat 16 auf 8 Dimensionen. 
   
   
  palette = "   n  b  g  bg r  br gr w  n+ b+ g+ bg+r+ br+gr+w+ " 
  *             0--1--2--3--4--5--6--7--8--9--10-11-12-13-14-15-16- 
   
  FOR colText = 1 TO 16                    
     
    FOR colBack = 1 TO 8                 
       
      array[colText,colBack] = TRIM( SUBSTR( palette, 1 + colText * 3, 3)) + "/" + TRIM( SUBSTR( palette, 1 + colBack * 3, 3)) 

    NEXT                                
     
  NEXT                                  
   
PROCEND                                 
   
* -------------------------------------------------------------- 